## pdal 1.9.1+ds

=== CMakeLists.txt ===
#
# top-level CMake configuration file for PDAL
#
# (based originally on the libLAS files copyright Mateusz Loskot)

cmake_minimum_required(VERSION 3.5)

project(PDAL CXX C)
string(TOLOWER ${PROJECT_NAME} PROJECT_NAME_LOWER)

set(ROOT_DIR "${PROJECT_SOURCE_DIR}")
include(${ROOT_DIR}/cmake/common.cmake NO_POLICY_SCOPE)

#------------------------------------------------------------------------------
# internal cmake settings
#------------------------------------------------------------------------------

set(CMAKE_COLOR_MAKEFILE ON)
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
include(FeatureSummary)

# Allow advanced users to generate Makefiles printing detailed commands
mark_as_advanced(CMAKE_VERBOSE_MAKEFILE)

#------------------------------------------------------------------------------
# PDAL general settings
#------------------------------------------------------------------------------

# the next line is the ONLY place in the entire pdal system where
# the version info is hard-coded
set(PDAL_VERSION_STRING "1.9.1" CACHE STRING "PDAL version")

DISSECT_VERSION()
GET_OS_INFO()
SET_INSTALL_DIRS()

set(PDAL_API_VERSION "8")
set(PDAL_BUILD_VERSION "9.0.1")

# Name of C++ library

#
# To facilitate one-library linking, we do special things for various platforms.
#
# On Linux we install a linker script that we call libpdalcpp.so and it
# in turn links libpdal_base.so and libpdal_util.so
#
# On OSX we reexport the symbols from libpdal_util.dylib into libpdalcpp.dylib
# See below for the rest of the magic.
#
if (APPLE OR WIN32)
    set(PDAL_LIB_NAME pdalcpp)
    set(PDAL_BASE_LIB_NAME pdalcpp)
else()
    set(PDAL_LIB_NAME pdalcpp)
    set(PDAL_BASE_LIB_NAME pdal_base)
endif()
set(PDAL_UTIL_LIB_NAME pdal_util)
set(PDAL_BOOST_LIB_NAME pdal_boost)
set(PDAL_KAZHDAN_LIB_NAME pdal_kazhdan)
set(PDAL_TEST_SUPPORT_OBJS pdal_test_support)

set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE ON)

set(PDAL_OUTPUT_LIB_DIR "${PDAL_BINARY_DIR}/${PDAL_LIB_INSTALL_DIR}")
set(PDAL_OUTPUT_BIN_DIR "${PDAL_BINARY_DIR}/${PDAL_BIN_INSTALL_DIR}")

# allow override of PDAL_PLUGIN_INSTALL_PATH path
if (NOT PDAL_PLUGIN_INSTALL_PATH)
    if (WIN32)
        set(PDAL_PLUGIN_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/${PDAL_BIN_INSTALL_DIR}")
    else()
        set(PDAL_PLUGIN_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/${PDAL_LIB_INSTALL_DIR}")
    endif()
endif()
file(MAKE_DIRECTORY "${PDAL_OUTPUT_LIB_DIR}")
file(MAKE_DIRECTORY "${PDAL_OUTPUT_BIN_DIR}")

include(${PDAL_CMAKE_DIR}/rpath.cmake)

# wipe lib/ drectory on clean. It will have plugins that could be out of date
# in the next build
set_directory_properties(PROPERTY ADDITIONAL_MAKE_CLEAN_FILES
    "${PDAL_OUTPUT_LIB_DIR}/*")

if(WIN32)
  add_definitions("-DPDAL_DLL_EXPORT=1")
  set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY_${CMAKE_BUILD_TYPE} "${PDAL_OUTPUT_LIB_DIR}")
  set(CMAKE_RUNTIME_OUTPUT_DIRECTORY_${CMAKE_BUILD_TYPE} "${PDAL_OUTPUT_BIN_DIR}")
  # ---[ Windows requires DLLs (shared libraries) to be installed in
  # ---[ the same directory as executables
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY_${CMAKE_BUILD_TYPE} "${PDAL_OUTPUT_BIN_DIR}")
endif(WIN32)

set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${PDAL_OUTPUT_LIB_DIR}")
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${PDAL_OUTPUT_BIN_DIR}")
if(WIN32)
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PDAL_OUTPUT_BIN_DIR}")
else()
  set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${PDAL_OUTPUT_LIB_DIR}")
endif()

# Choose package components

include(${PDAL_CMAKE_DIR}/options.cmake)

#------------------------------------------------------------------------------
# General build settings
#------------------------------------------------------------------------------

set(PDAL_BUILD_TYPE ${CMAKE_BUILD_TYPE})

#------------------------------------------------------------------------------
#  Dependencies.
#------------------------------------------------------------------------------

include(${PDAL_CMAKE_DIR}/gdal.cmake)
include(${PDAL_CMAKE_DIR}/geotiff.cmake)  # Optional (not really)
include(${PDAL_CMAKE_DIR}/lazperf.cmake)  # Optional
include(${PDAL_CMAKE_DIR}/laszip.cmake)  # Optional
include(${PDAL_CMAKE_DIR}/threads.cmake)
include(${PDAL_CMAKE_DIR}/zlib.cmake)
include(${PDAL_CMAKE_DIR}/lzma.cmake)
include(${PDAL_CMAKE_DIR}/zstd.cmake)
include(${PDAL_CMAKE_DIR}/test.cmake)
include(${PDAL_CMAKE_DIR}/ctest.cmake)
include(${PDAL_CMAKE_DIR}/json.cmake)
include(${PDAL_CMAKE_DIR}/libxml2.cmake)
include(${PDAL_CMAKE_DIR}/dimension.cmake)
include(${PDAL_CMAKE_DIR}/arbiter.cmake)

#------------------------------------------------------------------------------
# generate the pdal_features.hpp header
#------------------------------------------------------------------------------

# from http://stackoverflow.com/questions/1435953/how-can-i-pass-git-sha1-to-compiler-as-definition-using-cmake
include(GetGitRevisionDescription)
get_git_head_revision(GIT_REFSPEC GIT_SHA1)

configure_file(
  "${PROJECT_SOURCE_DIR}/gitsha.cpp.in"
  "${PROJECT_SOURCE_DIR}/pdal/gitsha.cpp")

# needs to come before configuration of pdal_features
if(APPLE)
    option(PDAL_BUNDLE "Create PDAL as Application Bundle on OSX" FALSE)
    if (PDAL_BUNDLE)
        set(PDAL_APP_BUNDLE 1)
    endif()
endif()

set(pdal_features_hpp_in "${CMAKE_CURRENT_SOURCE_DIR}/pdal_features.hpp.in")
set(pdal_features_hpp
    "${CMAKE_CURRENT_BINARY_DIR}/include/pdal/pdal_features.hpp")
configure_file(${pdal_features_hpp_in} ${pdal_features_hpp})

#------------------------------------------------------------------------------
# subdirectory controls
#------------------------------------------------------------------------------

# PDAL_TARGET_OBJECTS is used to collect the driver object libraries
set(PDAL_TARGET_OBJECTS "")

if (WITH_TESTS)
    enable_testing()
endif()

add_subdirectory(plugins)

#include_directories(vendor/pdalboost)
if (WITH_TESTS)
    include (${PDAL_CMAKE_DIR}/gtest.cmake)
    add_subdirectory(test)
endif()
add_subdirectory(dimbuilder)
add_subdirectory(vendor/pdalboost)
add_subdirectory(vendor/arbiter)
add_subdirectory(vendor/kazhdan)
if (NOT PDAL_HAVE_JSONCPP)
    add_subdirectory(vendor/jsoncpp/dist)
endif()
add_subdirectory(pdal/util)
add_subdirectory(tools)
add_subdirectory(apps)
#
# On OSX we reexport the symbols in libpdal_util.dylib into libpdalcpp.dylib
# so that users only need link libpdalcpp.
#
if (APPLE)
    set(PDAL_REEXPORT "-Wl,-reexport_library,$<TARGET_FILE:${PDAL_UTIL_LIB_NAME}>")
    #
    # This allows the rpath reference for the reexported library (above) to
    # be found.
    #
    set(PDAL_LIBDIR "-L$<TARGET_FILE_DIR:${PDAL_UTIL_LIB_NAME}>")
endif()

file(GLOB BASE_SRCS
    ${PDAL_FILTERS_DIR}/*.cpp
    ${PDAL_IO_DIR}/*.cpp
    ${PDAL_KERNELS_DIR}/*.cpp
    ${PDAL_SRC_DIR}/*.cpp
    ${PDAL_SRC_DIR}/compression/*.cpp)
file(GLOB_RECURSE PRIVATE_SRCS
    ${PDAL_FILTERS_DIR}/private/*.cpp
    ${PDAL_IO_DIR}/private/*.cpp
    ${PDAL_KERNELS_DIR}/private/*.cpp
    ${PDAL_SRC_DIR}/private/*.cpp)
list(APPEND SRCS ${BASE_SRCS} ${PRIVATE_SRCS})

#
# Remove stuff we don't want to build.
#
if (NOT PDAL_HAVE_LIBXML2)
    file(GLOB XML_SRCS
        io/Ilvis2MetadataReader.cpp
        io/Ilvis2Metadata.cpp
        io/Ilvis2Reader.cpp
        ${PDAL_SRC_DIR}/DbWriter.cpp
        ${PDAL_SRC_DIR}/DbReader.cpp
        ${PDAL_SRC_DIR}/XMLSchema.cpp)
    list(REMOVE_ITEM SRCS ${XML_SRCS})
endif()
if (NOT PDAL_HAVE_ZSTD)
    file(GLOB ZSTD_SRCS
        ${PDAL_SRC_DIR}/compression/ZstdCompression.cpp)
    list(REMOVE_ITEM SRCS ${ZSTD_SRCS})
endif()
if (NOT PDAL_HAVE_ZLIB)
    file(GLOB ZLIB_SRCS
        ${PDAL_SRC_DIR}/compression/DeflateCompression.cpp)
    list(REMOVE_ITEM SRCS ${ZLIB_SRCS})
endif()
if (NOT PDAL_HAVE_LZMA)
    file(GLOB LZMA_SRCS
        ${PDAL_SRC_DIR}/compression/LzmaCompression.cpp)
    list(REMOVE_ITEM SRCS ${LZMA_SRCS})
endif()
if (NOT PDAL_HAVE_LAZPERF)
    file(GLOB LAZPERF_SRCS
        ${PDAL_SRC_DIR}/compression/LazPerfCompression.cpp
        ${PDAL_SRC_DIR}/compression/LazPerfVlrCompression.cpp)
    list(REMOVE_ITEM SRCS ${LAZPERF_SRCS})
endif()
PDAL_ADD_LIBRARY(${PDAL_BASE_LIB_NAME} ${SRCS} ${RPLY_SRCS})

#
# Interface include directories allow downstream project to get the directory
# without specification.
#
target_include_directories(${PDAL_BASE_LIB_NAME}
    PRIVATE
        ${ROOT_DIR}
        ${PROJECT_BINARY_DIR}/include
        ${PDAL_VENDOR_DIR}
        ${PDAL_VENDOR_DIR}/eigen
        ${PDAL_VENDOR_DIR}/pdalboost
        ${PDAL_JSONCPP_INCLUDE_DIR}
        ${LIBXML2_INCLUDE_DIR}
        ${ZSTD_INCLUDE_DIRS}
    PUBLIC
        ${GDAL_INCLUDE_DIR}
        ${LASZIP_INCLUDE_DIR}
)
target_link_libraries(${PDAL_BASE_LIB_NAME}
    PRIVATE
        ${CMAKE_THREAD_LIBS_INIT}
        ${GDAL_LIBRARY}
        ${GEOTIFF_LIBRARY}
        ${LASZIP_LIBRARY}
        ${LIBXML2_LIBRARIES}
        ${ZLIB_LIBRARIES}
        ${LIBLZMA_LIBRARIES}
        ${ZSTD_LIBRARIES}
        ${WINSOCK_LIBRARY}
        ${PDAL_REEXPORT}
        ${PDAL_UTIL_LIB_NAME}
        ${PDAL_ARBITER_LIB_NAME}
        ${PDAL_KAZHDAN_LIB_NAME}
        ${PDAL_JSONCPP_LIB_NAME}
    INTERFACE
        ${PDAL_LIBDIR}
)
target_compile_definitions(${PDAL_BASE_LIB_NAME}
    PRIVATE
        ${LASZIP_DEFINES}
)
set_target_properties(${PDAL_BASE_LIB_NAME} PROPERTIES
    VERSION ${PDAL_BUILD_VERSION}
    SOVERSION ${PDAL_API_VERSION}
    CLEAN_DIRECT_OUTPUT 1)

# shut off -Wpedantic selectively
if (CMAKE_CXX_COMPILER_ID MATCHES "Clang" OR CMAKE_CXX_COMPILER_ID MATCHES "GNU" )
set_source_files_properties(filters/PoissonFilter.cpp PROPERTIES COMPILE_FLAGS -Wno-pedantic)
endif()

#
# On Linux, we install a linker script as libpdalcpp.so.  That file
# specifies linking in libpdal_base.so and libpdal_util.so.  This allows
# users to link a single library, libpdalcpp
#
if (UNIX AND NOT APPLE)
    set(LIBNAME ${CMAKE_SHARED_LIBRARY_PREFIX}${PDAL_LIB_NAME})
    install(FILES ${LIBNAME} DESTINATION ${PDAL_LIB_INSTALL_DIR}
        RENAME ${LIBNAME}${CMAKE_SHARED_LIBRARY_SUFFIX})
endif()

#
# Installation
#

#
# Only install compression headers if we're building with the particular
# compression type.
#
if (NOT PDAL_HAVE_ZSTD)
    set(ZSTD_EXCLUDES PATTERN pdal/compression/Zstd* EXCLUDE)
endif()
if (NOT PDAL_HAVE_ZLIB)
    set(ZLIB_EXCLUDES PATTERN pdal/compression/Deflate* EXCLUDE)
endif()
if (NOT PDAL_HAVE_LZMA)
    set(LZMA_EXCLUDES PATTERN pdal/compression/Lzma* EXCLUDE)
endif()
if (NOT PDAL_HAVE_LAZPERF)
    set(LAZPERF_EXCLUDES PATTERN pdal/compression/LazPerf* EXCLUDE)
endif()

install(DIRECTORY ${PDAL_INCLUDE_DIR}/pdal
    DESTINATION include
    FILES_MATCHING PATTERN "*.hpp"
    PATTERN "gitsha.h"
    PATTERN "pdal/private" EXCLUDE
    PATTERN "pdal/util/private" EXCLUDE
    ${ZSTD_EXCLUDES}
    ${ZLIB_EXCLUDES}
    ${LZMA_EXCLUDES}
    ${LAZPERF_EXCLUDES}
)

install(DIRECTORY ${PDAL_KERNELS_DIR}
    DESTINATION include/pdal
    FILES_MATCHING PATTERN "*.hpp"
    PATTERN "private" EXCLUDE
)
install(DIRECTORY ${PDAL_IO_DIR}
    DESTINATION include/pdal
    FILES_MATCHING PATTERN "*.hpp"
    PATTERN "private" EXCLUDE
)
install(DIRECTORY ${PDAL_FILTERS_DIR}
    DESTINATION include/pdal
    FILES_MATCHING PATTERN "*.hpp"
    PATTERN "private" EXCLUDE
)

install(FILES ${DIMENSION_OUTFILE} ${pdal_features_hpp}
  DESTINATION include/pdal
)

#
# CPACK
#
include (${PDAL_CMAKE_DIR}/cpack.cmake)

add_custom_target(dist COMMAND ${CMAKE_MAKE_PROGRAM} package_source)

export(
    TARGETS
        ${PDAL_BASE_LIB_NAME} ${PDAL_UTIL_LIB_NAME}
    FILE
        "${PDAL_BINARY_DIR}/PDALTargets.cmake")

install(
    EXPORT
        PDALTargets
    DESTINATION
        "${PDAL_LIB_INSTALL_DIR}/cmake/PDAL")
include(${PDAL_CMAKE_DIR}/config.cmake)
feature_summary(WHAT ALL INCLUDE_QUIET_PACKAGES)

# TODO: move under scripts/bash-completion ?
if (WITH_COMPLETION)
    if (IS_DIRECTORY ${CMAKE_INSTALL_PREFIX}/share/bash-completion/completions)
        install(
            FILES
                "${PROJECT_SOURCE_DIR}/scripts/bash-completion/pdal"
            DESTINATION
                "${CMAKE_INSTALL_PREFIX}/share/bash-completion/completions")

=== plugins/CMakeLists.txt ===
include(${PDAL_CMAKE_DIR}/test.cmake)

add_subdirectory(faux)
if(BUILD_PLUGIN_I3S)
    if(NOT ZLIB_FOUND)
        message(FATAL_ERROR "Can't build i3s and slpk plugins without zlib")
    endif()
    add_subdirectory(i3s)
endif()

if(BUILD_PLUGIN_CPD)
    add_subdirectory(cpd)
endif(BUILD_PLUGIN_CPD)

if(BUILD_PLUGIN_GEOWAVE)
    add_subdirectory(geowave)
endif(BUILD_PLUGIN_GEOWAVE)

if(BUILD_PLUGIN_GREYHOUND AND CURL_FOUND)
    add_subdirectory(greyhound)
endif()

if(BUILD_PLUGIN_ICEBRIDGE)
    if (NOT PDAL_HAVE_LIBXML2)
        message(FATAL_ERROR "Can't build icebridge plugin without libxml2")
    endif()
    add_subdirectory(icebridge)
endif()

if(BUILD_PLUGIN_MATLAB)
    add_subdirectory(matlab)
endif()

if(BUILD_PLUGIN_MBIO)
    add_subdirectory(mbio)
endif()

if(BUILD_PLUGIN_MRSID)
    add_subdirectory(mrsid)
endif()

if(BUILD_PLUGIN_NITF)
    add_subdirectory(nitf)
endif()

if(BUILD_PLUGIN_OCI)
    if (NOT PDAL_HAVE_LIBXML2)
        message(FATAL_ERROR "Can't build OCI plugin without libxml2")
    endif()
    add_subdirectory(oci)
endif()

if(BUILD_PLUGIN_PCL)
    add_subdirectory(pcl)
endif()

if(BUILD_PLUGIN_PGPOINTCLOUD)
    if (NOT PDAL_HAVE_LIBXML2)
        message(FATAL_ERROR "Can't build pgpointcloud plugin without libxml2")
    endif()
    add_subdirectory(pgpointcloud)
endif()

if(BUILD_PLUGIN_PYTHON)
    add_subdirectory(python)
endif()

if(BUILD_PLUGIN_OPENSCENEGRAPH)
    add_subdirectory(openscenegraph)
endif()

if(BUILD_PLUGIN_RDBLIB)
    add_subdirectory(rdb)
endif(BUILD_PLUGIN_RDBLIB)

if(BUILD_PLUGIN_RIVLIB)
    add_subdirectory(rxp)
endif(BUILD_PLUGIN_RIVLIB)

if(BUILD_PLUGIN_SQLITE)
    if (NOT PDAL_HAVE_LIBXML2)
        message(FATAL_ERROR "Can't build sqlite plugin without libxml2")
    endif()
    add_subdirectory(sqlite)
endif()

if (BUILD_PLUGIN_FBX)
    add_subdirectory(fbx)
endif()

if(BUILD_PLUGIN_TILEDB)
    add_subdirectory(tiledb)
endif()

=== plugins/fbx/CMakeLists.txt ===
#
# FBX plugin CMake configuration
#

set(FBX_INCLUDE_DIR
    "FBX_INCLUDE_DIR-NOTFOUND" CACHE PATH
    "Include directory for FBX header")
set(FBX_LIBRARY
    "FBX_LIBRARY-NOTFOUND" CACHE STRING
    "Full path to FBX library")
set_package_properties(Fbx PROPERTIES TYPE OPTIONAL)
if (EXISTS "${FBX_INCLUDE_DIR}/fbxsdk.h" AND
    EXISTS ${FBX_LIBRARY})
    set(FBX_FOUND true)
else()
    set(FBX_FOUND false)
endif()

if (APPLE)
    set(CORE_FOUNDATION "-framework CoreFoundation")
endif()

if (FBX_FOUND)
    PDAL_ADD_PLUGIN(writer_libname writer fbx
        FILES
            io/FbxWriter.cpp
        LINK_WITH
            ${FBX_LIBRARY}
            ${CORE_FOUNDATION}
        INCLUDES
            ${PDAL_IO_DIR}
            ${FBX_INCLUDE_DIR}
    )

    if (WITH_TESTS)
        PDAL_ADD_TEST(fbxtest
            FILES
                test/FbxWriterTest.cpp
            LINK_WITH
                ${writer_libname}
            INCLUDES
                ${PDAL_IO_DIR}
        )
    endif()
else()
    message(STATUS "Building without FBX support")
endif()

=== plugins/greyhound/CMakeLists.txt ===
#
# Greyhound plugin CMake configuration
#

add_definitions(-DHAVE_JSONCPP=1)
if (WIN32)
add_definitions("-DARBITER_DLL_IMPORT")
endif()

#
# Need Winsock for htonl
#

PDAL_ADD_PLUGIN(reader_libname reader greyhound
    FILES
        io/CompressionStream.cpp
        io/GreyhoundReader.cpp
        io/GreyhoundCommon.cpp
        io/bounds.cpp
    LINK_WITH
        ${PDAL_JSONCPP_LIB_NAME}
        ${WINSOCK_LIBRARY}
    INCLUDES
        ${PDAL_JSONCPP_INCLUDE_DIR}
        ${PDAL_VENDOR_DIR}
)

PDAL_ADD_PLUGIN(writer_libname writer greyhound
    FILES
        io/CompressionStream.cpp
        io/GreyhoundWriter.cpp
        io/GreyhoundCommon.cpp
        io/bounds.cpp
    LINK_WITH
        ${PDAL_JSONCPP_LIB_NAME}
        ${WINSOCK_LIBRARY}
    INCLUDES
        ${PDAL_JSONCPP_INCLUDE_DIR}
        ${PDAL_VENDOR_DIR}
)


if (WITH_TESTS)
    PDAL_ADD_TEST(pdal_io_greyhound_reader_test
        FILES
            test/GreyhoundReaderTest.cpp
        LINK_WITH
            ${reader_libname}
            ${writer_libname}
            ${PDAL_JSONCPP_LIB_NAME}
        INCLUDES
            ${PDAL_JSONCPP_INCLUDE_DIR}
            ${PDAL_VENDOR_DIR}
    )
endif()

=== plugins/i3s/CMakeLists.txt ===

include(${PDAL_CMAKE_DIR}/zlib.cmake)

add_subdirectory(lepcc)

PDAL_ADD_PLUGIN(i3s_reader_libname reader i3s
    FILES
      io/I3SReader.cpp
      io/EsriUtil.cpp
      io/SlpkExtractor.cpp
      io/EsriReader.cpp
    LINK_WITH
        ${PDAL_JSONCPP_LIB_NAME}
        ${WINSOCK_LIBRARY}
        ${GDAL_LIBRARY}
        ${ZLIB_LIBRARY}
        lepcc
    INCLUDES
        ${PDAL_JSONCPP_INCLUDE_DIR}
        ${PDAL_VENDOR_DIR}
        ${LEPCC_INCLUDE_DIR}
        ${PDAL_VENDOR_DIR}/eigen
        ${GDAL_INCLUDE_DIR}
)
target_compile_definitions(${i3s_reader_libname}
    PRIVATE
        ARBITER_ZLIB
        ARBITER_DLL_IMPORT
)

PDAL_ADD_PLUGIN(slpk_reader_libname reader slpk
    FILES
        io/SlpkReader.cpp
        io/EsriUtil.cpp
        io/EsriReader.cpp
        io/SlpkExtractor.cpp
    LINK_WITH
        ${PDAL_JSONCPP_LIB_NAME}
        ${WINSOCK_LIBRARY}
        ${GDAL_LIBRARY}
        ${ZLIB_LIBRARY}
        lepcc
    INCLUDES
        ${PDAL_JSONCPP_INCLUDE_DIR}
        ${PDAL_VENDOR_DIR}
        ${LEPCC_INCLUDE_DIR}
        ${PDAL_VENDOR_DIR}/eigen
        ${GDAL_INCLUDE_DIR}
)
target_compile_definitions(${slpk_reader_libname}
    PRIVATE
        ARBITER_ZLIB
        ARBITER_DLL_IMPORT
)

if (WITH_TESTS)
    PDAL_ADD_TEST(pdal_io_slpk_reader_test
            FILES
                test/SlpkReaderTest.cpp
            LINK_WITH
                ${slpk_reader_libname}
                ${PDAL_JSONCPP_LIB_NAME}
                ${GDAL_LIBRARY}
            INCLUDES
                ${PDAL_JSONCPP_INCLUDE_DIR}
                ${PDAL_VENDOR_DIR}
                ${LEPCC_INCLUDE_DIR}
                ${PDAL_VENDOR_DIR}/eigen
                ${GDAL_INCLUDE_DIR}
    )
    target_compile_definitions(pdal_io_slpk_reader_test
        PRIVATE
            ARBITER_ZLIB
            ARBITER_DLL_IMPORT
    )

    if (BUILD_I3S_TESTS)
        PDAL_ADD_TEST(pdal_io_i3s_reader_test
                FILES
                    test/i3sReaderTest.cpp
                LINK_WITH
                    ${i3s_reader_libname}
                    ${PDAL_JSONCPP_LIB_NAME}
                    ${GDAL_LIBRARY}
                INCLUDES
                    ${PDAL_JSONCPP_INCLUDE_DIR}
                    ${PDAL_VENDOR_DIR}
                    ${LEPCC_INCLUDE_DIR}
                    ${PDAL_VENDOR_DIR}/eigen
                    ${GDAL_INCLUDE_DIR}
        )
        target_compile_definitions(pdal_io_i3s_reader_test
            PRIVATE
                ARBITER_ZLIB
                ARBITER_DLL_IMPORT
        )
    endif()
endif()

=== plugins/matlab/CMakeLists.txt ===
# Matlab plugin

include(${PDAL_CMAKE_DIR}/matlab.cmake)

#set(CMAKE_SKIP_RPATH true)
#if (LINUX)

#endif()

PDAL_ADD_PLUGIN(libname_writer writer matlab
    FILES
        ./filters/Script.cpp
        io/MatlabWriter.cpp
    LINK_WITH
        ${Matlab_MX_LIBRARY}
        ${Matlab_MAT_LIBRARY}
    INCLUDES
        ${Matlab_INCLUDE_DIR}
)

PDAL_ADD_PLUGIN(libname_reader reader matlab
    FILES
        ./filters/Script.cpp
        io/MatlabReader.cpp
    LINK_WITH
        ${Matlab_MX_LIBRARY}
        ${Matlab_MAT_LIBRARY}
    INCLUDES
        ${Matlab_INCLUDE_DIR}
)


PDAL_ADD_PLUGIN(matlab_libname filter matlab
    FILES
        ./filters/Environment.cpp
        ./filters/Script.cpp
        ./filters/MatlabFilter.cpp
    LINK_WITH
        ${Matlab_ENG_LIBRARY}
        ${Matlab_MX_LIBRARY}
        ${Matlab_MAT_LIBRARY}
    INCLUDES
        ${Matlab_INCLUDE_DIR}
        ${PDAL_JSONCPP_INCLUDE_DIR}
)

if (WITH_TESTS)
    PDAL_ADD_TEST(pdal_io_matlab_writer_test
        FILES
            test/MatlabWriterTest.cpp
        LINK_WITH
           ${libname_writer}
        INCLUDES
            ${PDAL_IO_DIR}
            ${Matlab_INCLUDE_DIR}
    )
    set_target_properties(pdal_io_matlab_writer_test
        PROPERTIES
        INSTALL_RPATH "${CMAKE_CXX_IMPLICIT_LINK_DIRECTORIES}:${MATLAB_LIB_DIR}"
        BUILD_WITH_INSTALL_RPATH true
    )


    PDAL_ADD_TEST(pdal_io_matlab_reader_test
        FILES
            test/MatlabReaderTest.cpp
        LINK_WITH
           ${libname_reader}
        INCLUDES
            ${PDAL_IO_DIR}
            ${Matlab_INCLUDE_DIR}
    )
    set_target_properties(pdal_io_matlab_reader_test
        PROPERTIES
        INSTALL_RPATH "${CMAKE_CXX_IMPLICIT_LINK_DIRECTORIES}:${MATLAB_LIB_DIR}"
        BUILD_WITH_INSTALL_RPATH true
    )

    PDAL_ADD_TEST(pdal_filters_matlab_test
        FILES
            ./filters/Script.cpp
            ./filters/Environment.cpp
            ./test/MatlabFilterTest.cpp
        LINK_WITH
            ${Matlab_ENG_LIBRARY}
            ${Matlab_MX_LIBRARY}
            ${Matlab_MAT_LIBRARY}
        INCLUDES
            ${ROOT_DIR}
            ${Matlab_INCLUDE_DIR}
            ${PDAL_JSONCPP_INCLUDE_DIR}
    )
    set_target_properties(pdal_filters_matlab_test
        PROPERTIES
        INSTALL_RPATH "${CMAKE_CXX_IMPLICIT_LINK_DIRECTORIES}:${MATLAB_LIB_DIR}:${CMAKE_LIBRARY_OUTPUT_DIRECTORY}"
        BUILD_WITH_INSTALL_RPATH true
    )

endif()

=== plugins/mrsid/CMakeLists.txt ===
#
# MrSID plugin CMake configuration
#

set(MRSID_ROOT "/Users/hobu/installs/mrsid/Lidar_DSDK" CACHE STRING "Root directory of MrSID install")
find_package(MrSID)
if (MRSID_FOUND)
    PDAL_ADD_PLUGIN(reader_libname reader mrsid
        FILES
            io/MrsidReader.cpp
        LINK_WITH
            ${MRSID_LIBRARY}
        INCLUDES
            ${PDAL_IO_DIR}
            ${MRSID_INCLUDE_DIR}
    )
    target_compile_definitions(${reader_libname} PRIVATE -DHAVE_MRSID=1)

    if (WITH_TESTS)
        PDAL_ADD_TEST(mrsidtest
            FILES
                test/MrsidTest.cpp
            LINK_WITH
                ${reader_libname}
            INCLUDES
                ${PDAL_IO_DIR}
        )
    endif()
else()
    message(STATUS "Building without MrSID support")
endif()

=== plugins/rdb/CMakeLists.txt ===

find_package(rdb COMPONENTS REQUIRED)
set_package_properties(rdb PROPERTIES
    TYPE REQUIRED
    PURPOSE "Read data from RIEGL databases"
    )

PDAL_ADD_PLUGIN(libname reader rdb
    FILES
        io/RdbPointcloud.cpp
        io/RdbReader.cpp
    LINK_WITH
        ${PDAL_JSONCPP_LIB_NAME}
        rdbcpp
    INCLUDES
        ${PDAL_JSONCPP_INCLUDE_DIR}
        ${RDB_INCLUDE_CPP_DIR}
)
target_include_directories(${libname} PUBLIC "${PDAL_VENDOR_DIR}/eigen")

set(RDB_TEST_NAME pdal_io_rdb_reader_test)
option(BUILD_RDBLIB_TESTS "Build rdblib tests" ON)
if (BUILD_RDBLIB_TESTS)
    configure_file(
        test/Config.hpp.in
        "${CMAKE_CURRENT_BINARY_DIR}/test/Config.hpp"
    )

    PDAL_ADD_TEST(${RDB_TEST_NAME}
        FILES
            test/RdbReaderTest.cpp
        LINK_WITH
            ${libname}
        INCLUDES
            ${PROJECT_BINARY_DIR}/plugins/rdb/test
            ${PROJECT_SOURCE_DIR}/plugins/rdb/io
            ${RDB_INCLUDE_CPP_DIR}
    )
endif()

=== test/unit/CMakeLists.txt ===
###############################################################################
#
# test/unit/CMakeLists.txt controls building of PDAL unit tests suite
#
# Copyright (c) 2009 Mateusz Loskot <mateusz@loskot.net>
#
###############################################################################

configure_file(TestConfig.hpp.in "${CMAKE_CURRENT_BINARY_DIR}/TestConfig.hpp")

file(GLOB_RECURSE inFiles RELATIVE "${CMAKE_SOURCE_DIR}" "${CMAKE_SOURCE_DIR}/test/data/*.in")
foreach(infileName ${inFiles})
    string(REGEX REPLACE ".in\$" "" outfileName "${infileName}")
    configure_file("${CMAKE_SOURCE_DIR}/${infileName}"
        "${CMAKE_BINARY_DIR}/${outfileName}")
endforeach()

add_library(${PDAL_TEST_SUPPORT_OBJS} OBJECT Support.cpp)
add_dependencies(${PDAL_TEST_SUPPORT_OBJS} generate_dimension_hpp)
target_include_directories(${PDAL_TEST_SUPPORT_OBJS}
    PRIVATE
        ${ROOT_DIR}
        ${PROJECT_BINARY_DIR}/include
        ${PROJECT_BINARY_DIR}/test/unit
        ${PDAL_INCLUDE_DIR}
)
PDAL_TARGET_COMPILE_SETTINGS(${PDAL_TEST_SUPPORT_OBJS})

PDAL_ADD_TEST(pdal_bounds_test FILES BoundsTest.cpp)
PDAL_ADD_TEST(pdal_config_test FILES ConfigTest.cpp)
PDAL_ADD_TEST(pdal_eigen_test
    FILES EigenTest.cpp
    INCLUDES ${PDAL_VENDOR_DIR}/eigen)
PDAL_ADD_TEST(pdal_file_utils_test FILES FileUtilsTest.cpp)
PDAL_ADD_TEST(pdal_georeference_test FILES GeoreferenceTest.cpp)
PDAL_ADD_TEST(pdal_kdindex_test
    FILES KDIndexTest.cpp
    INCLUDES ${PDAL_VENDOR_DIR})
PDAL_ADD_TEST(pdal_kernel_test FILES KernelTest.cpp)
PDAL_ADD_TEST(pdal_log_test FILES LogTest.cpp)
PDAL_ADD_TEST(pdal_metadata_test FILES MetadataTest.cpp)
PDAL_ADD_TEST(pdal_oldpclblock_test FILES OldPCLBlockTest.cpp)

PDAL_ADD_TEST(pdal_options_test
    FILES
        OptionsTest.cpp
    LINK_WITH
        ${PDAL_JSONCPP_LIB_NAME}
        ${GDAL_LIBRARY}
    INCLUDES
        ${PDAL_JSONCPP_INCLUDE_DIR}
)

PDAL_ADD_TEST(pdal_pipeline_manager_test FILES PipelineManagerTest.cpp)
PDAL_ADD_TEST(pdal_pipeline_writer_test
    FILES
        PipelineWriterTest.cpp
    INCLUDES
        ${PDAL_JSONCPP_INCLUDE_DIR}
)
PDAL_ADD_TEST(pdal_plugin_manager_test FILES PluginManagerTest.cpp)
PDAL_ADD_TEST(pdal_point_view_test FILES PointViewTest.cpp)
PDAL_ADD_TEST(pdal_point_table_test FILES PointTableTest.cpp)

PDAL_ADD_TEST(pdal_program_arg_test
    FILES
        ProgramArgsTest.cpp
    LINK_WITH
        ${PDAL_JSONCPP_LIB_NAME}
    INCLUDES
        ${PDAL_JSONCPP_INCLUDE_DIR}
)
PDAL_ADD_TEST(pdal_artifact_test FILES ArtifactTest.cpp)

PDAL_ADD_TEST(pdal_polygon_test
    FILES
        PolygonTest.cpp
    LINK_WITH
        ${GDAL_LIBRARY}
)
target_include_directories(pdal_polygon_test
    PRIVATE
        ${GDAL_INCLUDE_DIR})
PDAL_ADD_TEST(pdal_segmentation_test FILES SegmentationTest.cpp)
PDAL_ADD_TEST(pdal_spatial_reference_test
    FILES
        SpatialReferenceTest.cpp
    LINK_WITH
        ${GDAL_LIBRARY}
    INCLUDES
        ${PDAL_JSONCPP_INCLUDE_DIR}
)

PDAL_ADD_TEST(pdal_stage_factory_test FILES StageFactoryTest.cpp)
PDAL_ADD_TEST(pdal_streaming_test FILES StreamingTest.cpp)
PDAL_ADD_TEST(pdal_support_test FILES SupportTest.cpp)
PDAL_ADD_TEST(pdal_utils_test FILES UtilsTest.cpp)
PDAL_ADD_TEST(pdal_uuid_test FILES UuidTest.cpp)
if (PDAL_HAVE_LAZ_PERF)
PDAL_ADD_TEST(pdal_lazperf_test FILES LazPerfTest.cpp)
endif()
if (PDAL_HAVE_ZLIB)
PDAL_ADD_TEST(pdal_deflate_test FILES DeflateTest.cpp)
endif()
if (PDAL_HAVE_LZMA)
PDAL_ADD_TEST(pdal_lzma_test FILES LzmaTest.cpp)
endif()
if (PDAL_HAVE_ZSTD)
PDAL_ADD_TEST(pdal_zstd_test FILES ZstdTest.cpp)
endif()

#
# sources for the native io
#
PDAL_ADD_TEST(pdal_io_bpf_base_test FILES io/BpfTestBase.cpp)
if (PDAL_HAVE_ZLIB)
    PDAL_ADD_TEST(pdal_io_bpf_zlib_test FILES io/BpfTestZlib.cpp)
endif()
PDAL_ADD_TEST(pdal_io_buffer_test FILES io/BufferTest.cpp)
PDAL_ADD_TEST(pdal_io_ept_reader_test
    FILES
        io/EptReaderTest.cpp
    LINK_WITH
        ${GDAL_LIBRARY} # EptReaderTest uses the crop filter.
    INCLUDES
        ${PDAL_JSONCPP_INCLUDE_DIR}
)
PDAL_ADD_TEST(pdal_io_ept_addon_writer_test
    FILES
        io/EptAddonWriterTest.cpp
    LINK_WITH
        ${PDAL_JSONCPP_LIB_NAME}
    INCLUDES
        ${PDAL_JSONCPP_INCLUDE_DIR}
)
PDAL_ADD_TEST(pdal_io_faux_test FILES io/FauxReaderTest.cpp)
PDAL_ADD_TEST(pdal_io_gdal_reader_test
    FILES
        io/GDALReaderTest.cpp
    LINK_WITH
        ${GDAL_LIBRARY}
)
    target_include_directories(pdal_io_gdal_reader_test
        PRIVATE
            ${GDAL_INCLUDE_DIR})

PDAL_ADD_TEST(pdal_io_gdal_writer_test
    FILES
        io/GDALWriterTest.cpp
    LINK_WITH
        ${GDAL_LIBRARY}
    INCLUDES
        ${GDAL_INCLUDE_DIR}
)
PDAL_ADD_TEST(pdal_io_las_reader_test
    FILES
        io/LasReaderTest.cpp
    INCLUDES
        ${PDAL_JSONCPP_INCLUDE_DIR}
)
PDAL_ADD_TEST(pdal_io_las_writer_test
    FILES
        io/LasWriterTest.cpp
    INCLUDES
        ${PDAL_JSONCPP_INCLUDE_DIR}
)

PDAL_ADD_TEST(pdal_io_optech_test FILES io/OptechReaderTest.cpp)
PDAL_ADD_TEST(pdal_io_ply_reader_test
    FILES
        io/PlyReaderTest.cpp
    INCLUDES
        ${PDAL_VENDOR_DIR}
)
PDAL_ADD_TEST(pdal_io_ply_writer_test
    FILES
        io/PlyWriterTest.cpp
    INCLUDES ${PDAL_VENDOR_DIR}
)
PDAL_ADD_TEST(pdal_io_pts_reader_test FILES io/PtsReaderTest.cpp)
PDAL_ADD_TEST(pdal_io_qfit_test FILES io/QFITReaderTest.cpp)
PDAL_ADD_TEST(pdal_io_sbet_reader_test FILES io/SbetReaderTest.cpp)
PDAL_ADD_TEST(pdal_io_sbet_writer_test FILES io/SbetWriterTest.cpp)
PDAL_ADD_TEST(pdal_io_terrasolid_test FILES io/TerrasolidReaderTest.cpp)
PDAL_ADD_TEST(pdal_io_text_writer_test FILES io/TextWriterTest.cpp)
PDAL_ADD_TEST(pdal_io_text_reader_test
    FILES
        io/TextReaderTest.cpp
    INCLUDES
        ${PDAL_JSONCPP_INCLUDE_DIR}
)

#
# sources for the native filters
#
PDAL_ADD_TEST(pdal_filters_assign_test FILES filters/AssignFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_chipper_test
    FILES
        filters/ChipperTest.cpp
    INCLUDES
        ${PDAL_JSONCPP_INCLUDE_DIR}
)
PDAL_ADD_TEST(pdal_filters_nndistance_test
    FILES
        filters/NNDistanceTest.cpp
    INCLUDES
        ${PDAL_JSONCPP_INCLUDE_DIR}
)
PDAL_ADD_TEST(pdal_filters_colorinterp_test
    FILES
        filters/ColorinterpFilterTest.cpp
    LINK_WITH
        ${GDAL_LIBRARY}
)
PDAL_ADD_TEST(pdal_filters_colorization_test
    FILES
        filters/ColorizationFilterTest.cpp
    LINK_WITH
        ${GDAL_LIBRARY}
)
PDAL_ADD_TEST(pdal_filters_crop_test
    FILES
        filters/CropFilterTest.cpp
    LINK_WITH
        ${GDAL_LIBRARY}
)
PDAL_ADD_TEST(pdal_filters_decimation_test FILES
    filters/DecimationFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_delaunay_test FILES filters/DelaunayFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_divider_test FILES filters/DividerFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_mongoexpression_test
    FILES
        filters/MongoExpressionFilterTest.cpp
    LINK_WITH
        ${PDAL_JSONCPP_LIB_NAME}
    INCLUDES
        ${PDAL_JSONCPP_INCLUDE_DIR}
)


PDAL_ADD_TEST(pdal_filters_ferry_test FILES filters/FerryFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_groupby_test FILES filters/GroupByFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_ht_test FILES filters/HeadTailFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_info_test FILES filters/InfoFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_neighborclassifier_test FILES filters/NeighborClassifierFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_locate_test FILES filters/LocateFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_merge_test FILES filters/MergeTest.cpp)
PDAL_ADD_TEST(pdal_morton_order_test FILES filters/MortonOrderTest.cpp)
PDAL_ADD_TEST(pdal_filters_additional_merge_test
    FILES
        filters/AdditionalMergeTest.cpp
    INCLUDES
        ${PDAL_JSONCPP_INCLUDE_DIR}
)
PDAL_ADD_TEST(pdal_filters_overlay_test FILES filters/OverlayFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_pmf_test FILES filters/PMFFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_reprojection_test FILES
    filters/ReprojectionFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_range_test FILES filters/RangeFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_randomize_test FILES filters/RandomizeFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_returns_test FILES filters/ReturnsFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_smrf_test FILES filters/SMRFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_sort_test
    FILES
        filters/SortFilterTest.cpp
    INCLUDES
        ${PDAL_JSONCPP_INCLUDE_DIR}
)
PDAL_ADD_TEST(pdal_filters_splitter_test FILES filters/SplitterTest.cpp)
PDAL_ADD_TEST(pdal_filters_stats_test FILES filters/StatsFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_transformation_test FILES
    filters/TransformationFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_hexbin_test FILES filters/HexbinFilterTest.cpp)
PDAL_ADD_TEST(pdal_filters_voxel_test FILES filters/VoxelTest.cpp)

PDAL_ADD_TEST(pdal_app_test FILES apps/AppTest.cpp)
PDAL_ADD_TEST(pdal_app_plugin_test FILES apps/AppPluginTest.cpp)
PDAL_ADD_TEST(pdal_info_test FILES apps/InfoTest.cpp)
PDAL_ADD_TEST(pdal_tile_test FILES apps/TileTest.cpp)
PDAL_ADD_TEST(pdal_tindex_test FILES apps/TIndexTest.cpp)
if (LASZIP_FOUND)
    PDAL_ADD_TEST(pdal_merge_test FILES apps/MergeTest.cpp)
endif()
PDAL_ADD_TEST(pc2pc_test FILES apps/pc2pcTest.cpp)

if (BUILD_PIPELINE_TESTS)
    PDAL_ADD_TEST(pcpipeline_test_json FILES apps/pcpipelineTestJSON.cpp)
endif()
PDAL_ADD_TEST(hausdorff_test FILES apps/HausdorffTest.cpp)
PDAL_ADD_TEST(random_test FILES apps/RandomTest.cpp)
PDAL_ADD_TEST(translate_test FILES apps/TranslateTest.cpp)

if(PDAL_HAVE_LIBXML2)
    PDAL_ADD_TEST(pdal_io_ilvis2_metadata_test
        FILES
            io/Ilvis2MetadataReaderTest.cpp
        INCLUDES
            ${LIBXML2_INCLUDE_DIR}
    )
    PDAL_ADD_TEST(pdal_io_ilvis2_reader_metadata_test
        FILES
            io/Ilvis2ReaderWithMDReaderTest.cpp
        INCLUDES
            ${LIBXML2_INCLUDE_DIR}
    )
    PDAL_ADD_TEST(xml_schema_test
        FILES
            XMLSchemaTest.cpp
        LINK_WITH
            ${LIBXML2_LIBRARIES}
        INCLUDES
            ${LIBXML2_INCLUDE_DIR}
    )
    PDAL_ADD_TEST(pdal_io_ilvis2_test
        FILES
            io/Ilvis2ReaderTest.cpp
        INCLUDES
            ${LIBXML2_INCLUDE_DIR}
    )
endif()

=== plugins/python/filters/CMakeLists.txt ===
set(PLANG ../plang/Invocation.cpp
          ../plang/Environment.cpp
          ../plang/Redirector.cpp
          ../plang/Script.cpp)

PDAL_ADD_PLUGIN(python_libname filter python
    FILES
        ${PLANG}
        PythonFilter.cpp
    LINK_WITH
        ${PYTHON_LIBRARY}
        ${PDAL_JSONCPP_LIB_NAME}
        ${CMAKE_DL_LIBS}
    INCLUDES
        ${PDAL_JSONCPP_INCLUDE_DIR}
    SYSTEM_INCLUDES
        ${PYTHON_ALL_INCLUDE_DIRS}
)

if (WITH_TESTS)
    PDAL_ADD_TEST(pdal_filters_python_test
        FILES
            ../test/PythonFilterTest.cpp
        LINK_WITH
            ${python_libname} ${PYTHON_LIBRARY}
        SYSTEM_INCLUDES
            ${PYTHON_ALL_INCLUDE_DIRS}
    )
endif()

=== debian/changelog ===
pdal (1.9.1+ds-2) unstable; urgency=medium

  * Drop rst2pdf build dependency, only HTML docs are built.
  * Update symbols for other architectures.

 -- Bas Couwenberg <sebastic@debian.org>  Wed, 24 Jul 2019 12:22:12 +0200

pdal (1.9.1+ds-1) unstable; urgency=medium

  * Update symbols for other architectures.
  * Update gbp.conf to use --source-only-changes by default.
  * Bump Standards-Version to 4.4.0, no changes.
  * Move from experimental to unstable.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 14 Jul 2019 18:53:22 +0200

pdal (1.9.1+ds-1~exp2) experimental; urgency=medium

  * Add liblaszip-dev to (build) dependencies.
  * Update symbols for other architectures.
  * Update LASzip related symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Sun, 19 May 2019 17:28:59 +0200

pdal (1.9.1+ds-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update 1.9.0 symbols for other architectures.
  * Update copyright years for Michael P. Gerlek.
  * Update 1.9.1 symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Thu, 09 May 2019 20:41:54 +0200

pdal (1.9.0+ds-1~exp1) experimental; urgency=medium

  * New upstream release.
  * Update 1.9~rc3 symbols for other architectures.
  * Strip pre-releases from symbols version.
  * Update 1.9.0 symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Tue, 09 Apr 2019 18:16:12 +0200

pdal (1.9~rc3+ds-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Drop cmake-python3-numpy.patch, applied upstream.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 05 Apr 2019 20:34:26 +0200

pdal (1.9~rc2+ds-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Update 1.9~rc1 symbols for other architectures.
  * Add patch to fix python3-numpy detection.
  * Drop empty arch list from symbol.

 -- Bas Couwenberg <sebastic@debian.org>  Fri, 05 Apr 2019 16:59:01 +0200

pdal (1.9~rc1+ds-1~exp1) experimental; urgency=medium

  * New upstream release candidate.
  * Bump Standards-Version to 4.3.0, no changes.
  * Update copyright file, changes:
    - Update copyright years for existing copyright holders
    - Add Peter L. Svendsen & TileDB, Inc to copyright holders
    - Drop Bruno Levy from copyright holders
    - Add license & copyright for delaunator.hpp
  * Bump minimum required libgdal-dev to 2.2.
  * Drop libgeos++-dev from build dependencies.
  * Switch Python plugin to Python 3.
  * Update path to CMake files.
  * Rename library packages for SONAME bump.
  * Strip pre-releases from symbols version.
  * Update symbols for amd64.

 -- Bas Couwenberg <sebastic@debian.org>  Sat, 30 Mar 2019 13:19:05 +0100

=== debian/control ===
Source: pdal
Section: science
Priority: optional
Maintainer: Debian GIS Project <pkg-grass-devel@lists.alioth.debian.org>
Uploaders: Bas Couwenberg <sebastic@debian.org>
Build-Depends: debhelper (>= 9),
               dh-python,
               autotools-dev,
               bash-completion,
               chrpath,
               cmake (>= 3.5),
               libboost-filesystem-dev,
               libboost-iostreams-dev,
               libboost-program-options-dev,
               libboost-system-dev,
               libboost-thread-dev,
               libgdal-dev (>= 2.2),
               libgeotiff-dev,
               libhdf5-dev,
               libjs-mathjax,
               libjsoncpp-dev,
               liblaszip-dev,
               libpq-dev,
               libproj-dev,
               libspatialite-dev,
               libsqlite3-dev,
               libsqlite3-mod-spatialite,
               libwebsocketpp-dev,
               libxml2-dev,
               pkg-kde-tools,
               python3-all-dev,
               python3-breathe,
               python3-numpy,
               python3-sphinx,
               python3-sphinx-bootstrap-theme,
               zlib1g-dev,
               docbook2x,
               docbook-xsl,
               docbook-xml,
               xsltproc
Standards-Version: 4.4.0
Vcs-Browser: https://salsa.debian.org/debian-gis-team/pdal
Vcs-Git: https://salsa.debian.org/debian-gis-team/pdal.git
Homepage: http://pdal.io/

Package: pdal
Architecture: any
Section: utils
Depends: ${shlibs:Depends},
         ${misc:Depends}
Suggests: pdal-doc
Description: Point Data Abstraction Library
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the PDAL utilities.

Package: pdal-doc
Architecture: all
Section: doc
Depends: libjs-mathjax,
         ${sphinxdoc:Depends},
         ${misc:Depends}
Suggests: libpdal-dev,
          pdal
Description: Point Data Abstraction Library - documentation
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the PDAL documentation.

Package: libpdal-base8
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Recommends: libpdal-plugins
Description: Point Data Abstraction Library - libpdal_base
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the libpdal_base shared library.

Package: libpdal-util8
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - libpdal_util
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the libpdal_util shared library.

Package: libpdal-dev
Architecture: any
Section: libdevel
Depends: libpdal-base8 (= ${binary:Version}),
         libpdal-util8 (= ${binary:Version}),
         libboost-filesystem-dev,
         libboost-iostreams-dev,
         libboost-program-options-dev,
         libboost-system-dev,
         libboost-thread-dev,
         libgdal-dev,
         libgeos++-dev,
         libgeotiff-dev,
         liblaszip-dev,
         libproj-dev,
         libxml2-dev,
         ${misc:Depends}
Suggests: pdal-doc
Description: Point Data Abstraction Library - development files
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the PDAL development files.

Package: libpdal-plugins
Architecture: any
Section: libs
Depends: libpdal-plugin-faux (= ${binary:Version}),
         libpdal-plugin-greyhound (= ${binary:Version}),
         libpdal-plugin-icebridge (= ${binary:Version}),
         libpdal-plugin-pgpointcloud (= ${binary:Version}),
         libpdal-plugin-python (= ${binary:Version}),
         libpdal-plugin-sqlite (= ${binary:Version}),
         ${misc:Depends}
Description: Point Data Abstraction Library - plugins
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This metapackage depends on the individual PDAL plugin packages.

Package: libpdal-plugin-faux
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - Faux plugin
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the Faux plugin.

Package: libpdal-plugin-greyhound
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - Greyhound plugin
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the Greyhound plugin.

Package: libpdal-plugin-icebridge
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - Icebridge plugin
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the Icebridge plugin.

Package: libpdal-plugin-pgpointcloud
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Point Data Abstraction Library - PostgreSQL PointCloud plugin
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.
 .
 PDAL should not be confused with PCL (Point Cloud Library). PCL is a
 library specifically designed to provide algorithmic analysis and
 modification of point clouds. PDAL provides a limited interface to the
 facilities of PCL, but does not in general attempt to duplicate its
 capabilities.
 .
 This package contains the PostgreSQL PointCloud plugin.

Package: libpdal-plugin-python
Architecture: any
Section: libs
Depends: ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Breaks: libpdal-plugin-numpy (<< 1.7.2-2~)
Replaces: libpdal-plugin-numpy (<< 1.7.2-2~)
Description: Point Data Abstraction Library - Python plugin
 PDAL is a BSD licensed library for translating and manipulating point
 cloud data of various formats. PDAL can be used to read, write and
 translate point cloud data in many formats. Support is included for
 input files of LAS, LAZ, SBET, BPF, QFIT and others. PDAL can also read
 from and write to databases that support point cloud storage, including
 Oracle, Postgres and SQLite.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1

# Enable hardening build flags
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

include /usr/share/dpkg/pkg-info.mk

CXXFLAGS += $(CPPFLAGS)

UPSTREAM_VERSION  = $(shell echo $(DEB_VERSION_UPSTREAM) | sed -e 's/\+.*//')

BUILD_DATE = $(shell LC_ALL=C date -u "+%d %B %Y" -d "@$(SOURCE_DATE_EPOCH)")

MANPAGES := $(wildcard debian/man/*.*.xml)

%:
	dh $@ --with python3,pkgkde_symbolshelper,sphinxdoc --parallel

override_dh_clean:
	if [ -e debian/gtest.config.guess ]; then \
		mv debian/gtest.config.guess vendor/gtest/build-aux/config.guess ; \
	fi
	if [ -e debian/gtest.config.sub ]; then \
		mv debian/gtest.config.sub   vendor/gtest/build-aux/config.sub ; \
	fi

	dh_clean debian/man/*.1

	$(RM) -r doc/html

override_dh_auto_configure:
	# Don't use outdated autotools helper files
	mv vendor/gtest/build-aux/config.guess debian/gtest.config.guess
	mv vendor/gtest/build-aux/config.sub   debian/gtest.config.sub

	cp /usr/share/misc/config.guess vendor/gtest/build-aux/config.guess
	cp /usr/share/misc/config.sub   vendor/gtest/build-aux/config.sub

	dh_auto_configure -- -DCMAKE_BUILD_TYPE=RelWithDebInfo \
	                     -DCMAKE_INSTALL_LIBDIR=lib \
	                     -DBUILD_PLUGIN_GREYHOUND=ON \
	                     -DBUILD_PLUGIN_ICEBRIDGE=ON \
	                     -DBUILD_PLUGIN_PYTHON=ON \
	                     -DBUILD_PLUGIN_SQLITE=ON \
	                     -DWITH_COMPLETION=ON

override_dh_auto_build:
	# Create man pages from DocBook XML
	for x in $(MANPAGES) ; do \
	  docbook2x-man --string-param header-3="$(BUILD_DATE)" $$x ; \
	  mv `basename $$x | sed 's/.xml$$//'` `dirname $$x` ; \
	done

	dh_auto_build

	sphinx-build doc/ doc/html/ && ln -s /usr/share/javascript/mathjax doc/html/_static/

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	# Exclude tests:
	# - pgpointcloudtest, requires configured PostgreSQL database
	# - pdal_spatial_reference_test, fails sometimes
	(cd obj-* && ctest --force-new-ctest-process --output-on-failure --exclude-regex "pgpointcloudtest|pdal_spatial_reference_test" || echo "Ignoring test failures")
endif

override_dh_auto_install:
	dh_auto_install

	# Strip RPATH
	chrpath --delete debian/tmp/usr/lib/libpdal_plugin_*.so

	# Move pkg-config file to Multi-Arch path
	mkdir debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)
	mv debian/tmp/usr/lib/pkgconfig debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/

override_dh_install:
	dh_install --list-missing

override_dh_python3:
	dh_python3 -plibpdal-plugin-python
	dh_numpy3 -plibpdal-plugin-python

override_dh_makeshlibs:
	dh_makeshlibs -- -v$(UPSTREAM_VERSION) -c0
